var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import React from "react";
import { EditorFieldParentType } from "../EditorField";
import EditorField from "../EditorField/EditorField";
import { getDefaultRegistry } from "../EditorRegistry";
import SdkContext from "../SdkContext";
import { useDebouncedCallback } from "use-debounce";
var Editor = function (props) {
    var schema = props.schema, _a = props.registry, registry = _a === void 0 ? getDefaultRegistry() : _a, _b = props.pointer, pointer = _b === void 0 ? "" : _b, onChange = props.onChange;
    var _c = React.useState(props.value), value = _c[0], setValue = _c[1];
    var _d = React.useState(), errorReport = _d[0], setErrorReport = _d[1];
    var sdk = React.useContext(SdkContext).sdk;
    var validateValue = useDebouncedCallback(function (newValue) { return __awaiter(_this, void 0, void 0, function () {
        var newErrorReport;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(sdk && sdk.field && sdk.field.validate)) return [3 /*break*/, 2];
                    return [4 /*yield*/, sdk.field.validate(newValue)];
                case 1:
                    newErrorReport = _a.sent();
                    setErrorReport(newErrorReport);
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); }, 300)[0];
    var handleChange = React.useCallback(function (newValue) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            setValue(newValue);
            if (onChange) {
                onChange(newValue);
            }
            validateValue(newValue);
            return [2 /*return*/];
        });
    }); }, [value, setValue, errorReport, setErrorReport, sdk]);
    return (React.createElement(EditorField, { pointer: pointer, errorReport: errorReport || [], parentType: EditorFieldParentType.EDITOR_ROOT, value: value, schema: schema, registry: registry, onChange: handleChange }));
};
export default Editor;
