var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import React from "react";
import { Tooltip, withStyles } from "@material-ui/core";
import { KeyboardArrowDown, KeyboardArrowRight } from "@material-ui/icons";
import clsx from "clsx";
import CardContainer from "../Chooser/Chooser";
import CardContainerActions from "../ChooserActions";
import CollapsibleSection from "../CollapsibleSection";
import CollapsibleSectionHeader from "../CollapsibleSectionHeader";
import ContentItemCard from "../ContentItemCard";
import { EditorFieldParentType } from "../EditorField";
import { AddIcon, DeleteIcon } from "../Icons";
import SdkContext from "../SdkContext";
import StyledFab from "../StyledFab";
import { getContentTypeCard, getContentTypeIcon } from "../utils/contentTypeSettings";
import { getExtensionParams } from "../utils/getExtensionParams";
import Visualization from "../Visualization";
import { ContentClient } from "dc-delivery-sdk-js";
var styles = {
    root: {
        width: "100%"
    },
    collapsibleBody: {
        padding: "0px"
    },
    header: {
        display: "inline-flex",
        "vertical-align": "middle"
    }
};
function getContentTypes(schema) {
    if (!schema.allOf) {
        return [];
    }
    var result = [];
    for (var _i = 0, _a = schema.allOf; _i < _a.length; _i++) {
        var subSchema = _a[_i];
        if (subSchema &&
            subSchema.properties &&
            subSchema.properties.contentType &&
            subSchema.properties.contentType.enum) {
            var contentTypes = subSchema.properties.contentType.enum;
            for (var _b = 0, contentTypes_1 = contentTypes; _b < contentTypes_1.length; _b++) {
                var contentType = contentTypes_1[_b];
                if (result.indexOf(contentType) === -1) {
                    result.push(contentType);
                }
            }
        }
    }
    return result;
}
var EditorContentLinkField = function (props) {
    var schema = props.schema, onChange = props.onChange, value = props.value, parentType = props.parentType, classes = props.classes;
    var sdk = React.useContext(SdkContext).sdk;
    var contentTypes = getContentTypes(schema);
    var hasValue = value != null && value._meta && value._meta.schema;
    var handleBrowse = React.useCallback(function () { return __awaiter(_this, void 0, void 0, function () {
        var contentLink, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 3, , 4]);
                    if (!sdk) return [3 /*break*/, 2];
                    return [4 /*yield*/, sdk.contentLink.get(contentTypes)];
                case 1:
                    contentLink = _b.sent();
                    if (contentLink && onChange) {
                        onChange(contentLink);
                    }
                    _b.label = 2;
                case 2: return [3 /*break*/, 4];
                case 3:
                    _a = _b.sent();
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); }, [onChange, sdk]);
    var handleDelete = React.useCallback(function (event) {
        if (onChange) {
            onChange(undefined);
        }
    }, [onChange]);
    var canCollapse = parentType !== EditorFieldParentType.EDITOR_ROOT;
    var _a = React.useState(true), isExpanded = _a[0], setExpandedState = _a[1];
    var handleExpand = function (expanded) {
        setExpandedState(expanded);
    };
    var Icon = isExpanded ? KeyboardArrowDown : KeyboardArrowRight;
    var cardContainer;
    var _b = React.useState(undefined), loadedContentItemId = _b[0], setLoadedContentItemId = _b[1];
    var _c = React.useState(undefined), contentItemJson = _c[0], setContentItemJson = _c[1];
    var handleFetchContentJson = React.useCallback(function () { return __awaiter(_this, void 0, void 0, function () {
        var contentClient, content, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(value && value.id && sdk)) return [3 /*break*/, 5];
                    setLoadedContentItemId(value.id);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    contentClient = new ContentClient({
                        account: "staging",
                        stagingEnvironment: sdk.stagingEnvironment
                    });
                    return [4 /*yield*/, contentClient.getContentItem(value.id)];
                case 2:
                    content = _a.sent();
                    setContentItemJson(content.toJSON());
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    setContentItemJson(undefined);
                    return [3 /*break*/, 4];
                case 4: return [3 /*break*/, 6];
                case 5:
                    setContentItemJson(undefined);
                    _a.label = 6;
                case 6: return [2 /*return*/];
            }
        });
    }); }, [value, setLoadedContentItemId, setContentItemJson]);
    if (hasValue && value.id && value.id !== loadedContentItemId) {
        handleFetchContentJson();
    }
    if (hasValue) {
        var contentTypeSettings = getExtensionParams(sdk && sdk.field ? sdk.field.schema : {}, {}).contentTypes;
        var iconUrl = getContentTypeIcon(contentTypeSettings, value.contentType);
        var cardTemplateUrl = getContentTypeCard(contentTypeSettings, value.contentType);
        cardContainer = (React.createElement(CardContainer, { variant: "populated-slot" },
            React.createElement(ContentItemCard, { label: contentItemJson && contentItemJson._meta
                    ? contentItemJson._meta.name || ""
                    : "", icon: iconUrl }, cardTemplateUrl && sdk ? (React.createElement(Visualization, { template: cardTemplateUrl, params: {
                    contentItemId: value.id,
                    stagingEnvironment: sdk.stagingEnvironment
                } })) : (undefined)),
            React.createElement(CardContainerActions, { variant: "populated-slot" },
                React.createElement(Tooltip, { title: "Delete" },
                    React.createElement(StyledFab, { variant: "dark", onClick: handleDelete }, DeleteIcon)))));
    }
    else {
        cardContainer = (React.createElement(CardContainer, { variant: "empty-slot" },
            React.createElement(CardContainerActions, { variant: "empty-slot" },
                React.createElement(Tooltip, { title: "Add" },
                    React.createElement(StyledFab, { variant: "light", onClick: handleBrowse }, AddIcon)))));
    }
    if (canCollapse) {
        return (React.createElement(CollapsibleSection, { onChange: handleExpand },
            React.createElement(CollapsibleSectionHeader, { icon: Icon, title: schema.title }),
            React.createElement("div", { className: clsx(classes.collapsibleBody) }, cardContainer)));
    }
    return cardContainer;
};
export default withStyles(styles, { name: "DcEditorContentLinkField" })(EditorContentLinkField);
