var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from "react";
import { withStyles } from "@material-ui/core";
import clsx from "clsx";
import CollapsibleSection from "../CollapsibleSection";
import { EditorFieldParentType } from "../EditorField";
import EditorField from "../EditorField/EditorField";
import { KeyboardArrowDown, KeyboardArrowRight } from "@material-ui/icons";
import CollapsibleSectionHeader from "../CollapsibleSectionHeader";
export var styles = {
    root: {
        width: "100%"
    },
    properties: {
        "margin-left": "17px",
        "list-style": "none",
        margin: "0px",
        padding: "0px"
    },
    property: {},
    rootProperties: {
        "margin-left": "0px"
    },
    rootProperty: {
        "border-left": "4px solid #e5e5e5",
        "padding-left": "15px",
        "margin-bottom": "17px"
    },
    collapsibleBody: {
        padding: "0px"
    },
    header: {
        display: "inline-flex",
        "vertical-align": "middle"
    }
};
var EditorObjectField = function (props) {
    var _a;
    var schema = props.schema, registry = props.registry, onChange = props.onChange, valueProp = props.value, classes = props.classes, parentType = props.parentType, errorReport = props.errorReport, pointer = props.pointer;
    var handleChange = React.useCallback(function (propertyName, propertyValue) {
        var _a;
        var newValue = __assign({}, valueProp, (_a = {}, _a[propertyName] = propertyValue, _a));
        if (onChange) {
            onChange(newValue);
        }
    }, [onChange, valueProp]);
    var value = valueProp || {};
    var properties = schema.properties || {};
    var propertyNames = Object.keys(properties);
    var propertySchemas = {};
    var required = schema.required || [];
    for (var _i = 0, propertyNames_1 = propertyNames; _i < propertyNames_1.length; _i++) {
        var propertyName = propertyNames_1[_i];
        var propertySchema = properties[propertyName] || {};
        if (!propertySchema.title) {
            propertySchema = __assign({}, propertySchema, { title: propertyName });
        }
        propertySchemas[propertyName] = propertySchema;
    }
    var children = (React.createElement("ul", { className: clsx(classes.properties, (_a = {},
            _a[classes.rootProperties] = parentType === EditorFieldParentType.EDITOR_ROOT,
            _a)) }, propertyNames.map(function (propertyName) {
        var _a;
        return (React.createElement("li", { key: propertyName, className: clsx(classes.property, (_a = {},
                _a[classes.rootProperty] = parentType === EditorFieldParentType.EDITOR_ROOT,
                _a)) },
            React.createElement(EditorField, { pointer: pointer + "/" + propertyName, errorReport: errorReport, parentType: EditorFieldParentType.OBJECT, schema: propertySchemas[propertyName], value: value[propertyName], registry: registry, required: required.indexOf(propertyName) !== -1, 
                // tslint:disable-next-line
                onChange: function (propertyValue) {
                    return handleChange(propertyName, propertyValue);
                } })));
    })));
    var canCollapse = parentType !== EditorFieldParentType.EDITOR_ROOT;
    var _b = React.useState(true), isExpanded = _b[0], setExpandedState = _b[1];
    var handleExpand = function (expanded) {
        setExpandedState(expanded);
    };
    if (canCollapse) {
        var Icon = isExpanded ? KeyboardArrowDown : KeyboardArrowRight;
        return (React.createElement(CollapsibleSection, { onChange: handleExpand },
            React.createElement(CollapsibleSectionHeader, { icon: Icon, title: schema.title }),
            React.createElement("div", { className: clsx(classes.collapsibleBody) }, children)));
    }
    return children;
};
export default withStyles(styles, { name: "DcEditorObjectField" })(EditorObjectField);
